

varying vec3 vertex,nav,normal;

uniform float level,level1,step_length;
uniform vec3 lightDir;
uniform vec3 box1,box2;

uniform vec3 pos;


//varying vec3 vertex;
const float delta=0.01;

//uniform vec3 color1;
const vec3 color0=vec3(0,1,0);
const vec3 color1=vec3(0,0,1);
const vec3 colori=vec3(1,1,1);

float Equ(in vec3 arg)
{
	
return sin(arg.x+cos(arg.y+arg.z)*4.0)*exp2(5.0-length(arg)+sin(arg.y*arg.z));
//	return sin(length(arg)*10.0);
}


vec3 GradEqu(in vec3 arg)
{
	float val = Equ(arg);
	
	return vec3(Equ(vec3(arg.x+delta,arg.y,arg.z))-val, Equ(vec3(arg.x,arg.y+delta,arg.z))-val, Equ(vec3(arg.x,arg.y,arg.z+delta))-val);
}
float inten(in vec3 norm)
{
	return (dot(norm,lightDir)+1.3)/2.3;
}


void main()
{
	//float level=1.0;
	//vec3 lightDir=vec3(1.0,0.0,0.0);
	vec3 norm = normal,color = vec3(0.0),ps = vertex;
	float e=Equ(ps);
	

	if(e >= level && e <= level1)
	{
		color = colori;
	}else
	{

		vec3 step  = normalize(vertex-pos)*step_length,step1;
		//step*=0.01/length(step);


		vec3 ps=vertex+nav,eye=normalize(nav);
		float i=500.0,j;
		ps+=step;
		if(e < level)
		{
		while(ps.x>=box1.x && ps.y>=box1.y && ps.z>=box1.z && ps.x<=box2.x && ps.y<=box2.y && ps.z<=box2.z && i>0.0)
		{
			e = Equ(ps);
		
			if(e >= level)
			{
				ps-=step;
				step1=step*0.1;
				for(j=15.0;j>0.0;j--)
				{
					ps+=step1;
					e = Equ(ps);
					
					if(e >= level)
					{
						ps-=step1;
						step1*=0.3;
					}
				}
				norm = normalize( GradEqu(ps) );
				j=dot(norm,step);
				if(j>0.0)
					norm=-norm;
				
				color+=color1;
				break;
				
			}
			ps+=step;
			i--;

			
		}
		}
		if(i==500.0)
		{
		while(ps.x>=box1.x && ps.y>=box1.y && ps.z>=box1.z && ps.x<=box2.x && ps.y<=box2.y && ps.z<=box2.z && i>0.0)
		{
			e = Equ(ps);
		
			if(e <= level1)
			{
				ps-=step;
				step1=step*0.1;
				for(j=15.0;j>0.0;j--)
				{
					ps+=step1;
					e = Equ(ps);
					
					if(e <= level1)
					{
						ps-=step1;
						step1*=0.3;
					}
				}
				norm = normalize( GradEqu(ps) );
				j=dot(norm,step);
				if(j>0.0)
					norm=-norm;
				
				color+=color0;
				break;
				
			}
			
		
			ps+=step;
			i--;
		}
		}
	}
	
	
	gl_FragColor = vec4(color*inten(norm),1.0);
}
